## openturns 1.26

=== CMakeLists.txt ===
#                                               -*- cmake -*-

cmake_minimum_required (VERSION 3.18)

# By default, build in Release mode. Must appear before project() command
set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "" Release Debug RelWithDebInfo MinSizeRel)
set (CMAKE_TRY_COMPILE_CONFIGURATION ${CMAKE_BUILD_TYPE})

project (openturns)

option (USE_EXTERNAL_LIBS            "Use external libs"                                                     ON)
option (USE_CUBA                     "Use Cuba library"                                                      ${USE_EXTERNAL_LIBS})
option (USE_TBB                      "Use Intel Threading Building Blocks library for multithreading"        ${USE_EXTERNAL_LIBS})
option (USE_HMAT                     "Use HMat library (enforces GPL license)"                               OFF)
option (USE_MUPARSER                 "Use muParser library"                                                  ${USE_EXTERNAL_LIBS})
option (USE_EXPRTK                   "Use ExprTK library"                                                    ON)
option (USE_LIBXML2                  "Use LibXml2 for XML support"                                           ${USE_EXTERNAL_LIBS})
option (USE_HDF5                     "Use HDF5 for high volume storage"                                      ${USE_EXTERNAL_LIBS})
option (USE_BOOST                    "Use Boost for distribution computation"                                ON)
option (USE_MPFR                     "Use MPFR for real valued special functions computation"                ${USE_EXTERNAL_LIBS})
option (USE_MPC                      "Use MPC for complex valued special functions computation"              ${USE_EXTERNAL_LIBS})
option (USE_SPHINX                   "Use sphinx for documentation"                                          OFF)
option (USE_NLOPT                    "Use NLopt for additional optimization algorithms"                      ${USE_EXTERNAL_LIBS})
option (USE_CERES                    "Use Ceres Solver for additional optimization algorithms"               ${USE_EXTERNAL_LIBS})
option (USE_CMINPACK                 "Use CMinpack for additional optimization algorithms"                   ${USE_EXTERNAL_LIBS})
option (USE_DLIB                     "Use dlib for additional optimization algorithms"                       ${USE_EXTERNAL_LIBS})
option (USE_HIGHS                    "Use HiGHS for additional optimization algorithms"                      ${USE_EXTERNAL_LIBS})
option (USE_IPOPT                    "Use Ipopt for nonlinear optimization"                                  ${USE_EXTERNAL_LIBS})
option (USE_BONMIN                   "Use Bonmin for MINLP problems"                                         ${USE_EXTERNAL_LIBS})
option (USE_PAGMO                    "Use Pagmo for multi-objective optimization"                            ${USE_EXTERNAL_LIBS})
option (USE_SPECTRA                  "Use Spectra for eigenvalues computation"                               ${USE_EXTERNAL_LIBS})
option (USE_PRIMESIEVE               "Use primesieve for prime numbers generation"                           ${USE_EXTERNAL_LIBS})
option (USE_OPENMP                   "Use OpenMP to disable threading"                                       ${USE_EXTERNAL_LIBS})
option (USE_OPENBLAS                 "Use OpenBLAS to disable threading"                                     ${USE_EXTERNAL_LIBS})
option (USE_NANOFLANN                "Use nanoflann for Nearest Neighbor search"                             ${USE_EXTERNAL_LIBS})

option (BUILD_PYTHON                 "Build the python module for the library"                               ON)
option (BUILD_SHARED_LIBS            "Build shared libraries"                                                ON)

# Defines our own module path
list (APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

set (OPENTURNS_HOME_ENV_VAR OPENTURNS_HOME)

include (GNUInstallDirs)

set (OPENTURNS_LIBRARY_PATH ${CMAKE_INSTALL_LIBDIR} CACHE STRING "The directory where the library is installed")
set (OPENTURNS_BIN_PATH ${CMAKE_INSTALL_BINDIR} CACHE STRING "Binary install path")
set (OPENTURNS_INCLUDE_PATH ${CMAKE_INSTALL_INCLUDEDIR} CACHE STRING "The directory where the header files are installed")
set (OPENTURNS_CONFIG_CMAKE_PATH ${CMAKE_INSTALL_LIBDIR}/cmake/openturns CACHE STRING "The directory where the CMake files are installed")
set (OPENTURNS_SYSCONFIG_PATH ${CMAKE_INSTALL_SYSCONFDIR} CACHE STRING "The directory where the configuration file is installed")
set (OPENTURNS_DATA_PATH ${CMAKE_INSTALL_DATAROOTDIR} CACHE STRING "The directory where the common files are installed")
set (OPENTURNS_DOC_PATH ${CMAKE_INSTALL_DOCDIR} CACHE STRING "The directory where the license files are installed")

if (WIN32)
  set (DEFAULT_TMP TEMP)
  set (PATH_SEP "\\;")
else ()
  set(DEFAULT_TMP /tmp)
  set (PATH_SEP ":")
endif()

set (OPENTURNS_TEMPDIR
      ${DEFAULT_TMP}
      CACHE PATH "The directory for temporary files. /tmp by default."
   )
set (TEMPDIR ${OPENTURNS_TEMPDIR})

if (NOT DEFINED LAPACK_LIBRARIES)
  find_package (LAPACK REQUIRED)
endif ()
list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${LAPACK_LIBRARIES})

if (USE_SPECTRA)
  find_package (Spectra 1.0 CONFIG)
endif ()
if (Spectra_FOUND)
  message(STATUS "Found Spectra: ${Spectra_DIR} (found suitable version \"${Spectra_VERSION}\")")
  set (OPENTURNS_HAVE_SPECTRA TRUE)
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES Spectra::Spectra)
  list (APPEND OPENTURNS_ENABLED_FEATURES "spectra")
  if (NOT TARGET Eigen3::Eigen)
    find_package (Eigen3 CONFIG)
  endif ()
endif()

if (USE_PRIMESIEVE)
  find_package (primesieve CONFIG)
  if (primesieve_FOUND)
    set (OPENTURNS_HAVE_PRIMESIEVE TRUE)
    message (STATUS "Found primesieve: ${primesieve_DIR} (found version ${primesieve_VERSION})")
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES primesieve::primesieve)
    list (APPEND OPENTURNS_ENABLED_FEATURES "primesieve")
  else ()
    # fallback to our macro if primesieveConfig is not provided
    find_package (primesieve)
    if (primesieve_FOUND)
      set (OPENTURNS_HAVE_PRIMESIEVE TRUE)
      list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${PRIMESIEVE_INCLUDE_DIRS})
      list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${PRIMESIEVE_LIBRARIES})
      list (APPEND OPENTURNS_ENABLED_FEATURES "primesieve")
    endif ()
  endif ()
endif ()

if (USE_TBB)
  find_package (TBB CONFIG)
  if (TBB_FOUND)
    message (STATUS "Found TBB: ${TBB_DIR} (found version ${TBB_VERSION})")
    set (TBB_LIBRARIES TBB::tbb)
  else ()
    # fallback to our macro
    find_package (TBB 2017)
  endif ()
endif ()
if (TBB_FOUND)
  set (OPENTURNS_HAVE_TBB TRUE)
  if (TBB_INCLUDE_DIRS)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${TBB_INCLUDE_DIRS})
  endif ()
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${TBB_LIBRARIES})
  if (MSVC OR WINTEL)
    set (OPENTURNS_TBB_NO_IMPLICIT_LINKAGE ON CACHE BOOL "Prevent implicit linkage against tbb.lib ")
  endif ()
  list (APPEND OPENTURNS_ENABLED_FEATURES "tbb")
endif ()

if (USE_MUPARSER)
  find_package (muparser 2.2.3 CONFIG)
  if (muparser_FOUND)
    set (MUPARSER_LIBRARIES muparser::muparser)
  else ()
    # fallback to our macro
    find_package (muparser 2.2.3 MODULE QUIET)
  endif ()
endif ()
if (muparser_FOUND)
  set (OPENTURNS_HAVE_MUPARSER TRUE)
  set (OPENTURNS_HAVE_ANALYTICAL_PARSER TRUE)
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${MUPARSER_LIBRARIES})
  if (MUPARSER_INCLUDE_DIRS)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MUPARSER_INCLUDE_DIRS})
  endif ()
  list (APPEND OPENTURNS_ENABLED_FEATURES "muparser")
  set (SYMBOLICPARSER_DEFAULT_BACKEND MuParser)
endif ()

if (USE_EXPRTK)
  set (OPENTURNS_HAVE_EXPRTK TRUE)
  set (OPENTURNS_HAVE_ANALYTICAL_PARSER TRUE)
  set (SYMBOLICPARSER_DEFAULT_BACKEND ExprTk)
endif ()
if (NOT OPENTURNS_HAVE_ANALYTICAL_PARSER)
  message(FATAL_ERROR "Analytical parser required, please enable either USE_MUPARSER or USE_EXPRTK")
endif ()

if (USE_HMAT)
  find_package (HMAT 1.7 CONFIG)
endif ()
if (HMAT_FOUND)
  message(STATUS "Found HMAT: ${HMAT_DIR} (found suitable version \"${HMAT_VERSION}\")")
  set (OPENTURNS_HAVE_HMAT TRUE)
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${HMAT_INCLUDE_DIRS})
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${HMAT_LIBRARIES})
  list (APPEND OPENTURNS_ENABLED_FEATURES "hmat")
endif ()

if (USE_LIBXML2)
  find_package (LibXml2)
endif ()
if (LibXml2_FOUND)
  set (OPENTURNS_HAVE_LIBXML2 TRUE)
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES LibXml2::LibXml2)
  list (APPEND OPENTURNS_ENABLED_FEATURES "libxml2")
endif ()

if (USE_HDF5)
  find_package(HDF5 COMPONENTS C CXX)
endif ()
if (HDF5_FOUND)
  set (OPENTURNS_HAVE_HDF5 TRUE)
  list (APPEND OPENTURNS_DEFINITIONS ${HDF5_DEFINITIONS})
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${HDF5_INCLUDE_DIRS})
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${HDF5_LIBRARIES})
  list (APPEND OPENTURNS_ENABLED_FEATURES "hdf5")
endif ()

if (USE_BOOST)
  find_package (Boost CONFIG 1.70)
  if (Boost_FOUND)
    message(STATUS "Found Boost: ${Boost_DIR} (found suitable version \"${Boost_VERSION}\")")
  endif ()

  # fallback to FindBoost before its deprecation
  if (CMAKE_VERSION VERSION_LESS 3.30 AND NOT Boost_FOUND)
    find_package (Boost MODULE 1.70)
  endif ()

  if (Boost_FOUND)
    set (OPENTURNS_HAVE_BOOST TRUE)
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES Boost::boost)
    list (APPEND OPENTURNS_ENABLED_FEATURES "boost")
    if (USE_MPC)
      find_package (MPC)
      if (MPC_FOUND)
        set (OPENTURNS_HAVE_MPC TRUE)
        list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MPC_INCLUDE_DIRS})
        list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${MPC_LIBRARIES})
        list (APPEND OPENTURNS_ENABLED_FEATURES "mpc")
      endif ()
    endif ()
    if (USE_MPFR)
      find_package (MPFR)
      if (MPFR_FOUND)
        set (OPENTURNS_HAVE_MPFR TRUE)
        list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MPFR_INCLUDE_DIRS})
        list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${MPFR_LIBRARIES})
        list (APPEND OPENTURNS_ENABLED_FEATURES "mpfr")
      endif ()
    endif ()
  endif ()
endif ()

if (USE_CUBA)
  find_package (Cuba)
  if (Cuba_FOUND)
    set (OPENTURNS_HAVE_CUBA TRUE)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${CUBA_INCLUDE_DIRS})
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${CUBA_LIBRARIES})
    list (APPEND OPENTURNS_ENABLED_FEATURES "cuba")
  endif ()
endif ()

if (USE_NLOPT)
  find_package (NLopt 2.6 CONFIG)
  if (NLopt_FOUND)
    message(STATUS "Found NLopt: ${NLopt_DIR}  (found version \"${NLopt_VERSION}\")")
    set (OPENTURNS_HAVE_NLOPT TRUE)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${NLOPT_INCLUDE_DIRS})
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${NLOPT_LIBRARIES})
    list (APPEND OPENTURNS_ENABLED_FEATURES "nlopt")
  endif ()
endif ()

if (USE_DLIB)
  find_package (dlib 19.8 CONFIG)
  if (dlib_FOUND)
    set (OPENTURNS_HAVE_DLIB TRUE)
    message (STATUS "Found dlib: ${dlib_DIR} (found version ${dlib_VERSION})")
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES dlib::dlib)
    list (APPEND OPENTURNS_ENABLED_FEATURES "dlib")
  endif ()
endif ()

if (USE_CERES)
  find_package (Ceres CONFIG)
  if (Ceres_FOUND AND CERES_USES_MINIGLOG)
    message (STATUS "Ceres was built with miniglog and will likely leak logs to stderr (prefer glog), disabling.")
    set (Ceres_FOUND FALSE)
  endif ()
  if (Ceres_FOUND AND "SuiteSparse" IN_LIST CERES_COMPILED_COMPONENTS)
    message (STATUS "Ceres was built with SuiteSparse GPL components, disabling.")
    set (Ceres_FOUND FALSE)
  endif ()
  if (Ceres_FOUND)
    set (OPENTURNS_HAVE_CERES TRUE)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${CERES_INCLUDE_DIRS})
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${CERES_LIBRARIES})
    list (APPEND OPENTURNS_ENABLED_FEATURES "ceres")
  else ()
    # https://github.com/ceres-solver/ceres-solver/issues/1024
    list (APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
  endif ()
endif ()

=== lib/CMakeLists.txt ===
#                                               -*- cmake -*-

# Recurse in subdirectories
add_subdirectory (include)
add_subdirectory (src)
add_subdirectory (etc)

# Build the OpenTURNSConfig.cmake file
set (OPENTURNS_LIBRARY_DIRS            ${LIBRARY_PATH})
set (OPENTURNS_LIBRARY                 OT)
list (APPEND OPENTURNS_LIBRARIES       ${OPENTURNS_LIBRARY})
set (OPENTURNS_INCLUDE_DIR             ${INCLUDE_PATH})
list (INSERT OPENTURNS_INCLUDE_DIRS 0  ${OPENTURNS_INCLUDE_DIR})

set (OPENTURNS_ROOT_DIR       ${INSTALL_PATH})
set (OPENTURNS_VERSION_STRING ${PACKAGE_VERSION})
set (OPENTURNS_VERSION_MAJOR  ${CPACK_PACKAGE_VERSION_MAJOR})
set (OPENTURNS_VERSION_MINOR  ${CPACK_PACKAGE_VERSION_MINOR})
set (OPENTURNS_VERSION_PATCH  ${CPACK_PACKAGE_VERSION_PATCH})

include(CMakePackageConfigHelpers)
configure_package_config_file (OpenTURNSConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
  INSTALL_DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH}
  PATH_VARS
    OPENTURNS_ROOT_DIR
    OPENTURNS_INCLUDE_DIR
    OPENTURNS_INCLUDE_DIRS
    OPENTURNS_LIBRARY_DIRS
    OPENTURNS_SWIG_INCLUDE_DIRS
    PYTHON_MODULE_PATH
  NO_CHECK_REQUIRED_COMPONENTS_MACRO)

write_basic_package_version_file(OpenTURNSConfigVersion.cmake VERSION ${OPENTURNS_VERSION_STRING} COMPATIBILITY AnyNewerVersion)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfigVersion.cmake
         DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH})

# Recurse in subdirectories : test should be run after src (for target OT to be built)
add_subdirectory (test)

install (FILES ${HEADERFILES} DESTINATION ${OPENTURNS_INCLUDE_PATH}/openturns)

=== lib/src/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()
ot_install_header_file (OT.hxx)

# Recurse in subdirectories
add_subdirectory (Base)
add_subdirectory (Uncertainty)

set_source_files_properties (Base/Func/SpecFunc/Faddeeva.cc PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)

# Avoids propagating BOOST_MATH_NO_LONG_DOUBLE_MATH_FUNCTIONS to other boost-based code
if (Boost_FOUND)
  set_source_files_properties (Base/Func/SpecFunc/BetaFunctions.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  set_source_files_properties (Uncertainty/Distribution/StudentFunctions.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  set_source_files_properties (Base/Geom/Mesh.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    set_source_files_properties (Base/Geom/Mesh.cxx PROPERTIES COMPILE_FLAGS "-Wno-error=maybe-uninitialized")
  endif ()
endif ()

# Exclude Ceres sources from unity build (templates take much memory)
if (Ceres_FOUND)
  set_source_files_properties (Base/Optim/Ceres.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude Dlib sources from unity build (Lapack re-included)
if (dlib_FOUND)
  set_source_files_properties (Base/Optim/Dlib.cxx Base/Optim/DlibFunctions.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude Ipopt sources
if (Ipopt_FOUND)
  set_source_files_properties (Base/Optim/Ipopt.cxx Base/Optim/IpoptProblem.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    set_source_files_properties (Base/Optim/Ipopt.cxx Base/Optim/IpoptProblem.cxx PROPERTIES COMPILE_FLAGS "-Wno-error=suggest-override")
  endif ()
endif ()

# Exclude Bonmin sources
if (Bonmin_FOUND)
  set_source_files_properties (Base/Optim/Bonmin.cxx Base/Optim/BonminProblem.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    set_source_files_properties (Base/Optim/Bonmin.cxx Base/Optim/BonminProblem.cxx PROPERTIES COMPILE_FLAGS "-Wno-error=unused-parameter -Wno-error=overloaded-virtual -Wno-error=implicit-fallthrough")
  endif ()
  if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set_source_files_properties (Base/Optim/Bonmin.cxx Base/Optim/BonminProblem.cxx PROPERTIES COMPILE_FLAGS "-Wno-error=unused-parameter -Wno-error=overloaded-virtual")
  endif ()
endif ()

if (Pagmo_FOUND)
  set_source_files_properties (Base/Optim/Pagmo.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
     set_source_files_properties (Base/Optim/Pagmo.cxx PROPERTIES COMPILE_FLAGS "-Wno-error=cpp")
  endif ()
endif ()

if (highs_FOUND)
  set_source_files_properties (Base/Optim/HiGHS.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude LibXML sources
if (LIBXML2_FOUND)
  set_source_files_properties (Base/Common/XMLStorageManager.cxx Base/Common/XMLToolbox.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude HDF5 sources
if (LIBXML2_FOUND AND HDF5_FOUND)
  set_source_files_properties (Base/Common/XMLH5StorageManager.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude HMAT sources
if (HMAT_FOUND)
  set_source_files_properties (Base/Stat/HMatrixFactory.cxx Base/Stat/HMatrixImplementation.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

if (nanoflann_FOUND)
  set_source_files_properties (Base/Algo/KDTree.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# SymbolicParserExprTk.cxx includes exprtk.hpp which is huge, exclude it from unity builds
# It also causes problems on Windows
if (OPENTURNS_HAVE_EXPRTK)
  set_source_files_properties (Base/Func/SymbolicParserExprTk.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  if (MINGW)
    set_source_files_properties (Base/Func/SymbolicParserExprTk.cxx PROPERTIES COMPILE_FLAGS "-Wa,-mbig-obj -g0")
  endif ()
  if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set_source_files_properties (Base/Func/SymbolicParserExprTk.cxx PROPERTIES COMPILE_FLAGS "-Wno-shadow")
  endif ()
endif()

# Exclude spectra sources from unity build (templates take a lot of memory)
if (Spectra_FOUND)
  set_source_files_properties (Base/Algo/KarhunenLoeveP1Algorithm.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude cuba sources
if (Cuba_FOUND)
  set_source_files_properties (Base/Algo/CubaIntegration.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Build main library
include_directories (BEFORE ${INTERNAL_INCLUDE_DIRS})
add_library (OT ${SOURCEFILES} ${HEADERFILES})
set_target_properties (OT PROPERTIES POSITION_INDEPENDENT_CODE ON)

target_compile_definitions(OT PRIVATE ${OPENTURNS_DEFINITIONS})
if (NOT BUILD_SHARED_LIBS)
  target_compile_definitions (OT PUBLIC "OT_STATIC")
endif ()

# soversion
set_target_properties (OT PROPERTIES SOVERSION 0.27)
set (LIB_VERSION 0.27.0)
set_target_properties (OT PROPERTIES VERSION ${LIB_VERSION})

target_link_libraries (OT PRIVATE ${OPENTURNS_PRIVATE_LIBRARIES})

target_include_directories (OT INTERFACE $<INSTALL_INTERFACE:include>)
target_include_directories (OT PUBLIC ${OPENTURNS_INCLUDE_DIRS})

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.1)
  target_link_libraries (OT PRIVATE stdc++fs)
endif ()
target_compile_features (OT PUBLIC cxx_std_17)

set_property (TARGET OT PROPERTY OPENTURNS_ENABLED_FEATURES "${OPENTURNS_ENABLED_FEATURES}")
set_property (TARGET OT APPEND PROPERTY EXPORT_PROPERTIES "OPENTURNS_ENABLED_FEATURES")

# Add targets to the build-tree export set
export(TARGETS OT FILE "${PROJECT_BINARY_DIR}/OpenTURNS-Targets.cmake")

# Install the export set for use with the install-tree
install(EXPORT OpenTURNS-Targets DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH} COMPONENT Development)

# Install rules for library and executable
install (TARGETS OT
          EXPORT  OpenTURNS-Targets
          RUNTIME DESTINATION ${OPENTURNS_BIN_PATH}
          LIBRARY DESTINATION ${OPENTURNS_LIBRARY_PATH}
          ARCHIVE DESTINATION ${OPENTURNS_LIBRARY_PATH})

if (UNIX AND BUILD_SHARED_LIBS)
  set (OT_GDB_PY ${CMAKE_SHARED_LIBRARY_PREFIX}OT${CMAKE_SHARED_LIBRARY_SUFFIX}.${LIB_VERSION}-gdb.py)
  execute_process (COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/libOT-gdb.py ${CMAKE_CURRENT_BINARY_DIR}/${OT_GDB_PY})
  install (FILES libOT-gdb.py DESTINATION ${OPENTURNS_DATA_PATH}/gdb/auto-load${LIBRARY_PATH} RENAME ${OT_GDB_PY})
endif ()

=== lib/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright 2005-2025 Airbus-EDF-IMACS-ONERA-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#

set (CHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${PROJECT_BINARY_DIR}/lib/etc")

# This macro compiles and runs a C++ test
set (CHECK_TO_BE_RUN)
macro (ot_check_test TESTNAME)
  set (TEST_TARGET t_${TESTNAME})
  add_executable (${TEST_TARGET} EXCLUDE_FROM_ALL ${TEST_TARGET}.cxx)
  add_dependencies(tests ${TEST_TARGET})
  target_include_directories(${TEST_TARGET} PRIVATE ${INTERNAL_INCLUDE_DIRS} BEFORE)
  target_link_libraries (${TEST_TARGET} PRIVATE OT)
  set_target_properties (${TEST_TARGET} PROPERTIES
                         UNITY_BUILD OFF
                         INSTALL_RPATH "${PROJECT_BINARY_DIR}/lib/src;${CMAKE_INSTALL_RPATH}")
  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    if (${_ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    endif ()
  endforeach ()

  if (_IGNOREOUT)
    add_test (NAME cppcheck_${TESTNAME} COMMAND ${TEST_TARGET})
  else ()
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_TARGET}.expout)
    if (NOT EXISTS ${OUTFILE_LOC})
      message (SEND_ERROR "Missing file ${OUTFILE_LOC}")
    endif ()
    add_test (NAME cppcheck_${TESTNAME} COMMAND "sh" "-c" "(${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:${TEST_TARGET}> > ${CMAKE_CURRENT_BINARY_DIR}/${TEST_TARGET}.out) && diff -u --strip-trailing-cr ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TEST_TARGET}.out")
  endif ()
  set_tests_properties (cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}")
  list (APPEND CHECK_TO_BE_RUN ${TEST_TARGET})
endmacro ()


# Common
ot_check_test (Object_std)
ot_check_test (OStream_std)
ot_check_test (PersistentObject_std)
ot_check_test (Pointer_std)
ot_check_test (Pointer_cast)
ot_check_test (Exception_std IGNOREOUT)
ot_check_test (Log_std)
find_package (Threads)
target_link_libraries (t_Log_std PRIVATE ${CMAKE_THREAD_LIBS_INIT})
ot_check_test (IdFactory_std IGNOREOUT)
ot_check_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
  ot_check_test (Study_saveload)
  if (HDF5_FOUND)
    ot_check_test (Study_h5)
  endif ()
endif ()
ot_check_test (ResourceMap_std IGNOREOUT)
ot_check_test (Catalog_std IGNOREOUT)
ot_check_test (AtomicInt_std IGNOREOUT)
target_link_libraries (t_AtomicInt_std PRIVATE ${CMAKE_THREAD_LIBS_INIT})

# Type
ot_check_test (BipartiteGraph_std)
ot_check_test (Collection_std)
ot_check_test (Indices_std)
ot_check_test (IndicesCollection_std)
ot_check_test (Description_std)
ot_check_test (Point_std)
ot_check_test (Point_description)
ot_check_test (Matrix_std)
ot_check_test (SparseMatrix_std)
ot_check_test (IdentityMatrix_std)
ot_check_test (Tensor_std)
ot_check_test (ComplexTensor_std)
ot_check_test (SymmetricTensor_std)
ot_check_test (SquareMatrix_std)
ot_check_test (TriangularMatrix_std)
ot_check_test (SymmetricMatrix_std)
ot_check_test (Matrix_solve)
ot_check_test (Matrix_decomposition)
ot_check_test (SquareMatrix_lapack)
ot_check_test (SymmetricMatrix_lapack)
ot_check_test (Cache_std)
ot_check_test (ComplexMatrix_std)
ot_check_test (SquareComplexMatrix_std)
ot_check_test (HermitianMatrix_std)
ot_check_test (TriangularComplexMatrix_std)

# Func
ot_check_test (LinearEvaluation_std)
ot_check_test (ConstantGradient_std)
ot_check_test (AggregatedEvaluation_std)
ot_check_test (PiecewiseLinearEvaluation_std)
ot_check_test (PiecewiseHermiteEvaluation_std)
ot_check_test (P1LagrangeEvaluation_std)
if (OPENTURNS_HAVE_EXPRTK)
ot_check_test (SymbolicEvaluation_std)
ot_check_test (SymbolicGradient_std)
ot_check_test (SymbolicHessian_std)
ot_check_test (SymbolicFunction_std)
endif ()
if (OPENTURNS_HAVE_MUPARSER)
ot_check_test (SymbolicEvaluation_muparser)
ot_check_test (SymbolicGradient_muparser)
ot_check_test (SymbolicHessian_muparser)
ot_check_test (SymbolicFunction_muparser)
endif ()
ot_check_test (TranslationFunction_std)
ot_check_test (LinearFunction_std)
ot_check_test (LinearCombinationEvaluation_std)
ot_check_test (LinearCombinationGradient_std)
ot_check_test (LinearCombinationHessian_std)
ot_check_test (QuadraticEvaluation_std)
ot_check_test (LinearGradient_std)
ot_check_test (ConstantHessian_std)
ot_check_test (MethodBoundEvaluation_std)
ot_check_test (IndicatorFunction_std IGNOREOUT)
ot_check_test (DistanceToDomainFunction_std IGNOREOUT)
ot_check_test (AggregatedFunction_std)
ot_check_test (DualLinearCombinationFunction_std)
ot_check_test (LinearCombinationFunction_std)
ot_check_test (Function_operations)
ot_check_test (ParametricFunction_std)
ot_check_test (DatabaseFunction_std)
ot_check_test (MemoizeFunction_std)

ot_check_test (Function_draw)
ot_check_test (MonomialFunction_std)
ot_check_test (MonomialFunctionFactory_std)
ot_check_test (TensorizedUniVariateFunctionFactory_std)

ot_check_test (UniVariatePolynomial_std)
ot_check_test (Basis_std)
ot_check_test (BasisSequence_std)
ot_check_test (LARS_std)
ot_check_test (FieldFunction_std)
ot_check_test (FieldToPointFunction_std)
ot_check_test (PointToFieldFunction_std)
ot_check_test (ValueFunction_std)
ot_check_test (VertexValueFunction_std)
ot_check_test (PointToPointEvaluation_std)
ot_check_test (PointToPointConnection_std)
ot_check_test (PointToFieldConnection_std)
ot_check_test (FieldToPointConnection_std)
ot_check_test (FieldToFieldConnection_std)
ot_check_test (BoxCoxEvaluation_std)
ot_check_test (BoxCoxTransform_std)
ot_check_test (InverseBoxCoxEvaluation_std)
ot_check_test (InverseBoxCoxTransform_std)
ot_check_test (TrendEvaluation_std)
ot_check_test (TrendTransform_std)
ot_check_test (InverseTrendEvaluation_std)
ot_check_test (InverseTrendTransform_std)
ot_check_test (ExpertMixture_std)
ot_check_test (BasisFactory_std)

# Optim
ot_check_test (AbdoRackwitz_std)
if (Ceres_FOUND)
ot_check_test (Ceres_std)
endif ()
if (CMinpack_FOUND)
ot_check_test (CMinpack_std)
endif ()
ot_check_test (Cobyla_std)
if (dlib_FOUND)
  ot_check_test (Dlib_std IGNOREOUT)
  ot_check_test (Dlib_global IGNOREOUT)
endif()
if (Bonmin_FOUND)
  ot_check_test (Bonmin_std IGNOREOUT)
endif()

ot_check_test (SQP_std)
ot_check_test (TNC_std)
ot_check_test (NearestPointChecker_std)
if (NLopt_FOUND)
  ot_check_test (NLopt_std IGNOREOUT)
endif ()
ot_check_test (MultiStart_std IGNOREOUT)

# Solver
ot_check_test (Bisection_std)
ot_check_test (Brent_std)
ot_check_test (LeastSquaresEquationsSolver_std IGNOREOUT)
ot_check_test (Secant_std)
ot_check_test (RungeKutta_std)
ot_check_test (Fehlberg_std)

# Stat
ot_check_test (Sample_std)
ot_check_test (Sample_split)
ot_check_test (Sample_large)
ot_check_test (Sample_computation)
ot_check_test (Sample_operators)
ot_check_test (HistoryStrategy_std)
ot_check_test (CovarianceMatrix_std)
ot_check_test (CorrelationMatrix_std)
ot_check_test (TestResult_std)
ot_check_test (Field_draw)
ot_check_test (Field_std)
ot_check_test (ProcessSample_std)
ot_check_test (RandomGenerator_std)
ot_check_test (SobolSequence_std IGNOREOUT)
ot_check_test (FaureSequence_std IGNOREOUT)
ot_check_test (HaltonSequence_std IGNOREOUT)
ot_check_test (HaselgroveSequence_std)
ot_check_test (ReverseHaltonSequence_std)
ot_check_test (CorrelationAnalysis_std IGNOREOUT)
ot_check_test (TimeSeries_std)
ot_check_test (FilteringWindows_std)
ot_check_test (WelchFactory_std)
ot_check_test (ExponentialModel_std)
ot_check_test (CovarianceModel_std IGNOREOUT)
ot_check_test (DiracCovarianceModel_std)
ot_check_test (ExponentiallyDampedCosineModel_std)
ot_check_test (CauchyModel_std)
ot_check_test (UserDefinedSpectralModel_std)
ot_check_test (UserDefinedCovarianceModel_std)
ot_check_test (UserDefinedStationaryCovarianceModel_std)
ot_check_test (StationaryCovarianceModelFactory_std)
ot_check_test (NonStationaryCovarianceModelFactory_std)
ot_check_test (LatentVariableModel_std IGNOREOUT)
if (HMAT_FOUND)
ot_check_test (HMatrix_LDLt)
ot_check_test (HMatrix_LLt)
ot_check_test (HMatrix_LU)
ot_check_test (HMatrix_block_LLt)
ot_check_test (HMatrix_block_LU)
ot_check_test (DiracCovarianceModel_hmat)
endif ()

# Diff
ot_check_test (FiniteDifferenceStep_std)

# Geom
ot_check_test (Domain_std)
ot_check_test (Interval_std)
ot_check_test (IntervalMesher_std)
ot_check_test (LevelSet_std)
ot_check_test (LevelSetMesher_std)
ot_check_test (Mesh_std)
ot_check_test (Mesh_draw)
ot_check_test (RegularGrid_std)
ot_check_test (DomainComplement_std)
ot_check_test (DomainDifference_std)
ot_check_test (DomainIntersection_std)
ot_check_test (DomainUnion_std)
ot_check_test (DomainDisjunctiveUnion_std)

# Graph
ot_check_test (BarPlot_std)
ot_check_test (Cloud_std)
ot_check_test (Contour_std)
ot_check_test (Curve_std)
ot_check_test (Drawable_std)
ot_check_test (Graph_mix)
ot_check_test (Pie_std)
ot_check_test (Polygon_std)
ot_check_test (PolygonArray_std)
ot_check_test (Staircase_std)
ot_check_test (Text_std)

# Algo
ot_check_test (PenalizedLeastSquaresAlgorithm_std)
ot_check_test (CorrectedLeaveOneOut_std)
ot_check_test (KDTree_std)
ot_check_test (RegularGridNearestNeighbour_std)
ot_check_test (NaiveNearestNeighbour_std)
ot_check_test (NearestNeighbour1D_std)
ot_check_test (BoundingVolumeHierarchy_std)
ot_check_test (NaiveEnclosingSimplex_std)
ot_check_test (RegularGridEnclosingSimplex_std IGNOREOUT)
ot_check_test (EnclosingSimplexMonotonic1D_std IGNOREOUT)
ot_check_test (KFold_std)
ot_check_test (LeastSquaresMetaModelSelectionFactory_std)
ot_check_test (KissFFT_std)
ot_check_test (FilonQuadrature_std)
if (Cuba_FOUND)
  ot_check_test (CubaIntegration_std IGNOREOUT)
endif ()
ot_check_test (GaussKronrod_std)
ot_check_test (GaussLegendre_std)
ot_check_test (FejerAlgorithm_std IGNOREOUT)
ot_check_test (IteratedQuadrature_std)
ot_check_test (KarhunenLoeveP1Algorithm_std)
if (OPENTURNS_HAVE_HMAT AND OPENTURNS_HAVE_SPECTRA)
  ot_check_test (KarhunenLoeveP1Algorithm_hmat)
endif ()
if (OPENTURNS_HAVE_SPECTRA)
  ot_check_test (KarhunenLoeveP1Algorithm_spectra)
endif ()
ot_check_test (DesignProxy_std)
ot_check_test (LeastSquaresMethod_std)
ot_check_test (LeastSquaresMethod_weighted)
ot_check_test (KarhunenLoeveSVDAlgorithm_std)
ot_check_test (KarhunenLoeveLifting_std)
ot_check_test (KarhunenLoeveProjection_std)
ot_check_test (P1LagrangeInterpolation_std)
ot_check_test (SimplicialCubature_std IGNOREOUT)

# Analytical
ot_check_test (Analytical_std)
ot_check_test (AnalyticalResult_std)
ot_check_test (FORM_std)
ot_check_test (FORM_AbdoRackwitz)
ot_check_test (FORM_SQP)
ot_check_test (FORM_sensitivity)
ot_check_test (FORM_draw)
ot_check_test (SORM_std)
ot_check_test (StrongMaximumTest_std)
ot_check_test (StrongMaximumTest_tabulatedValues)
ot_check_test (StrongMaximumTest_other)

# Distribution
ot_check_test (Arcsine_std)
ot_check_test (ArcsineFactory_std)
ot_check_test (Bernoulli_std)
ot_check_test (BernoulliFactory_std)
ot_check_test (BernsteinCopulaFactory_std)
ot_check_test (Beta_std)
ot_check_test (BetaFactory_std)
ot_check_test (Binomial_std)
ot_check_test (BinomialFactory_std)
ot_check_test (BlockIndependentDistribution_std)
ot_check_test (Burr_std)
ot_check_test (BurrFactory_std)
ot_check_test (Chi_std)
ot_check_test (ChiFactory_std)
ot_check_test (ChiSquare_std)
ot_check_test (ChiSquareFactory_std)
ot_check_test (BlockIndependentCopula_std)
ot_check_test (JointDistribution_std)
ot_check_test (JointDistribution_large)
ot_check_test (CombinationsDistribution_std)
ot_check_test (CompositeDistribution_std)
ot_check_test (CompoundDistribution_std)

=== python/src/CMakeLists.txt ===
#                                               -*- cmake -*-

add_definitions (${OPENTURNS_SWIG_DEFINITIONS})

set (CMAKE_SWIG_FLAGS "" CACHE STRING "SWIG flags for generating wrapper code")

# allows one to pass compile flags like -O1 to reduce memory usage
set (SWIG_COMPILE_FLAGS "" CACHE STRING "C/C++ compiler flags used for wrapper code")
set (SWIG_CXX_COMPILE_FLAGS "" CACHE STRING "C++ specific compiler flags used for wrapper code")

# generate SWIG runtime header
execute_process (COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/openturns)
add_custom_command (OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/openturns/swigpyrun.h
                     COMMAND ${SWIG_EXECUTABLE}
                     ARGS -python -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/openturns/swigpyrun.h
                     COMMENT "Swig runtime header")
add_custom_target (generate_swig_runtime DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/openturns/swigpyrun.h)
add_custom_target (pylib)

set (OPENTURNS_PYTHON_MODULES)
macro (ot_add_python_module MODULENAME SOURCEFILE)
  set_source_files_properties (${SOURCEFILE} PROPERTIES CPLUSPLUS ON)
  set_source_files_properties (${SOURCEFILE} PROPERTIES SWIG_MODULE_NAME ${MODULENAME})
  set_source_files_properties (${SOURCEFILE} PROPERTIES INCLUDE_DIRECTORIES "${INTERNAL_INCLUDE_DIRS};${CMAKE_CURRENT_SOURCE_DIR}")

  ot_install_swig_file (${SOURCEFILE})
  if (${ARGC} GREATER 2)
    set (SWIG_MODULE_${MODULENAME}_EXTRA_DEPS ${ARGN})
  endif ()
  list (APPEND SWIG_MODULE_${MODULENAME}_EXTRA_DEPS openturns/PythonWrappingFunctions.hxx)

  set (swig_other_sources)
  foreach (it ${ARGN})
    if (${it} MATCHES ".*\\.i$")
      ot_install_swig_file (${it})
    else ()
      list (APPEND swig_other_sources "${it}")
    endif ()
  endforeach ()

  # swig_add_module is deprecated
  swig_add_library (${MODULENAME} LANGUAGE python SOURCES ${SOURCEFILE} ${swig_other_sources})

  add_dependencies (${MODULENAME} generate_swig_runtime)
  target_include_directories (${MODULENAME} PRIVATE ${INTERNAL_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} BEFORE)

  target_link_libraries (${MODULENAME} OT)
  target_link_libraries (${MODULENAME} Python::Module)

  # https://github.com/swig/swig/issues/2638
  target_compile_definitions(${MODULENAME} PRIVATE SWIG_PYTHON_SILENT_MEMLEAK)

  set_target_properties (${MODULENAME} PROPERTIES COMPILE_FLAGS "${SWIG_COMPILE_FLAGS} ${SWIG_CXX_COMPILE_FLAGS}")
  set_target_properties (${MODULENAME} PROPERTIES UNITY_BUILD OFF)

  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${MODULENAME}.py
           DESTINATION ${OPENTURNS_PYTHON_MODULE_PATH}/openturns)
  install (TARGETS ${MODULENAME}
            LIBRARY DESTINATION ${OPENTURNS_PYTHON_MODULE_PATH}/openturns)

  add_dependencies (pylib ${MODULENAME})
  list (APPEND OPENTURNS_PYTHON_MODULES ${MODULENAME})
endmacro ()

install (DIRECTORY openturns DESTINATION ${OPENTURNS_INCLUDE_PATH})

ot_add_python_module(common common_module.i
                      OTtypes.i
                      OTexceptions.i
                      TBB.i TBB_doc.i
                      Object.i Object_doc.i
                      PersistentObject.i PersistentObject_doc.i
                      Study.i Study_doc.i
                      StorageManager.i StorageManager_doc.i
                      XMLStorageManager.i XMLStorageManager_doc.i
                      XMLH5StorageManager.i XMLH5StorageManager_doc.i
                      Log.i Log_doc.i
                      TTY.i TTY_doc.i
                      Path.i Path_doc.i
                      Catalog.i
                      ResourceMap.i ResourceMap_doc.i
                      ComparisonOperatorImplementation.i
                      ComparisonOperator.i ComparisonOperator_doc.i
                      Equal.i Equal_doc.i
                      Greater.i Greater_doc.i
                      GreaterOrEqual.i GreaterOrEqual_doc.i
                      Less.i Less_doc.i
                      LessOrEqual.i LessOrEqual_doc.i
                      Cache.i
                      Pointer.i
                      InterfaceObject.i InterfaceObject_doc.i
                      TypedInterfaceObject.i
                      TypedCollectionInterfaceObject.i
                      BaseCommonTemplateDefs.i
                   )

if (LibXml2_FOUND)
  set_property (TARGET common APPEND PROPERTY SWIG_COMPILE_DEFINITIONS OPENTURNS_HAVE_LIBXML2=1)
endif ()

if (HDF5_FOUND)
  set_property (TARGET common APPEND PROPERTY SWIG_COMPILE_DEFINITIONS OPENTURNS_HAVE_HDF5=1)
endif ()

ot_add_python_module(typ typ_module.i
                      Collection.i Collection_doc.i
                      PersistentCollection.i
                      Description.i Description_doc.i
                      PlatformInfo.i PlatformInfo_doc.i
                      Point.i Point_doc.i
                      PointWithDescription.i PointWithDescription_doc.i
                      DomainImplementation.i DomainImplementation_doc.i
                      Interval.i Interval_doc.i
                      Indices.i Indices_doc.i
                      IndicesCollection.i IndicesCollection_doc.i
                      IndicesCollectionImplementation.i
                      MatrixImplementation.i
                      Matrix.i Matrix_doc.i
                      SquareMatrix.i SquareMatrix_doc.i
                      SymmetricMatrix.i SymmetricMatrix_doc.i
                      Tensor.i Tensor_doc.i
                      SymmetricTensor.i SymmetricTensor_doc.i
                      ComplexTensor.i ComplexTensor_doc.i
                      ComplexMatrix.i ComplexMatrix_doc.i
                      HermitianMatrix.i HermitianMatrix_doc.i
                      SquareComplexMatrix.i SquareComplexMatrix_doc.i
                      TriangularMatrix.i TriangularMatrix_doc.i
                      TriangularComplexMatrix.i TriangularComplexMatrix_doc.i
                      CovarianceMatrix.i CovarianceMatrix_doc.i
                      CorrelationMatrix.i CorrelationMatrix_doc.i
                      IdentityMatrix.i IdentityMatrix_doc.i
                      Sample.i Sample_doc.i
                      HistoryStrategyImplementation.i HistoryStrategyImplementation_doc.i
                      HistoryStrategy.i HistoryStrategy_doc.i
                      BaseTypCollection.i
                      BaseTypTemplateDefs.i
                   )

ot_add_python_module(statistics statistics_module.i
                      Compact.i Compact_doc.i
                      Full.i Full_doc.i
                      Last.i Last_doc.i
                      Null.i Null_doc.i
                      TestResult.i TestResult_doc.i
                      RandomGenerator.i RandomGenerator_doc.i
                      RandomGeneratorState.i RandomGeneratorState_doc.i
                      LowDiscrepancySequenceImplementation.i LowDiscrepancySequenceImplementation_doc.i
                      LowDiscrepancySequence.i LowDiscrepancySequence_doc.i
                      SobolSequence.i SobolSequence_doc.i
                      FaureSequence.i FaureSequence_doc.i
                      HaltonSequence.i HaltonSequence_doc.i
                      HaselgroveSequence.i HaselgroveSequence_doc.i
                      ReverseHaltonSequence.i ReverseHaltonSequence_doc.i
                      SphericalModel.i SphericalModel_doc.i
                      FilteringWindowsImplementation.i FilteringWindowsImplementation_doc.i
                      FilteringWindows.i FilteringWindows_doc.i
                      Hamming.i Hamming_doc.i
                      Hann.i Hann_doc.i
                      FFTImplementation.i FFTImplementation_doc.i
                      FFT.i FFT_doc.i
                      SpectralModelImplementation.i SpectralModelImplementation_doc.i
                      SpectralModel.i SpectralModel_doc.i
                      CovarianceModelImplementation.i CovarianceModelImplementation_doc.i
                      CovarianceModel.i CovarianceModel_doc.i
                      StationaryFunctionalCovarianceModel.i StationaryFunctionalCovarianceModel_doc.i
                      SpectralModelFactoryImplementation.i SpectralModelFactoryImplementation_doc.i
                      SpectralModelFactory.i SpectralModelFactory_doc.i
                      UserDefinedSpectralModel.i UserDefinedSpectralModel_doc.i
                      WelchFactory.i WelchFactory_doc.i
                      KroneckerCovarianceModel.i KroneckerCovarianceModel_doc.i
                      ExponentialModel.i ExponentialModel_doc.i
                      ExponentiallyDampedCosineModel.i ExponentiallyDampedCosineModel_doc.i
                      CauchyModel.i CauchyModel_doc.i
                      CovarianceModelFactoryImplementation.i CovarianceModelFactoryImplementation_doc.i
                      CovarianceModelFactory.i CovarianceModelFactory_doc.i
                      UserDefinedCovarianceModel.i UserDefinedCovarianceModel_doc.i
                      UserDefinedStationaryCovarianceModel.i UserDefinedStationaryCovarianceModel_doc.i
                      StationaryCovarianceModelFactory.i StationaryCovarianceModelFactory_doc.i
                      NonStationaryCovarianceModelFactory.i NonStationaryCovarianceModelFactory_doc.i
                      SquaredExponential.i SquaredExponential_doc.i
                      GeneralizedExponential.i GeneralizedExponential_doc.i
                      AbsoluteExponential.i AbsoluteExponential_doc.i
                      MaternModel.i MaternModel_doc.i
                      DiracCovarianceModel.i DiracCovarianceModel_doc.i
                      ProductCovarianceModel.i ProductCovarianceModel_doc.i
                      RankMCovarianceModel.i RankMCovarianceModel_doc.i
                      FractionalBrownianMotionModel.i FractionalBrownianMotionModel_doc.i
                      TensorizedCovarianceModel.i TensorizedCovarianceModel_doc.i
                      HMatrixParameters.i HMatrixParameters_doc.i
                      HMatrixFactory.i HMatrixFactory_doc.i
                      HMatrix.i HMatrix_doc.i
                      HMatrixImplementation.i HMatrixImplementation_doc.i
                      BaseStatisticsTemplateDefs.i
                      IsotropicCovarianceModel.i IsotropicCovarianceModel_doc.i
                      CorrelationAnalysis.i CorrelationAnalysis_doc.i
                      LatentVariableModel.i LatentVariableModel_doc.i
                      SamplePartition.i SamplePartition_doc.i
                   )

ot_add_python_module(iterative_statistics iterative_statistics_module.i
                      IterativeAlgorithm.i IterativeAlgorithm_doc.i
                      IterativeAlgorithmImplementation.i IterativeAlgorithmImplementation_doc.i
                      IterativeExtrema.i IterativeExtrema_doc.i
                      IterativeThresholdExceedance.i IterativeThresholdExceedance_doc.i
                      IterativeMoments.i IterativeMoments_doc.i
                      BaseIterativeStatisticsTemplateDefs.i
                   )

ot_add_python_module(geom geom_module.i
                      Domain.i Domain_doc.i
                      BipartiteGraph.i BipartiteGraph_doc.i
                      Mesh.i Mesh_doc.i
                      RegularGrid.i RegularGrid_doc.i
                      IntervalMesher.i IntervalMesher_doc.i
                      BoundaryMesher.i BoundaryMesher_doc.i
                      MeshDomain.i MeshDomain_doc.i
                      DomainComplement.i DomainComplement_doc.i
                      DomainIntersection.i DomainIntersection_doc.i
                      DomainUnion.i DomainUnion_doc.i
                      DomainDisjunctiveUnion.i DomainDisjunctiveUnion_doc.i
                      DomainDifference.i DomainDifference_doc.i
                      BaseGeomTemplateDefs.i
                    )

ot_add_python_module(graph graph_module.i
                      DrawableImplementation.i DrawableImplementation_doc.i

=== python/test/CMakeLists.txt ===
#                                               -*- cmake -*-

set (PYINSTALLCHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${INSTALL_DESTDIR}${SYSCONFIG_PATH}/openturns"
                                 "PYTHONPATH=${INSTALL_DESTDIR}${PYTHON_MODULE_PATH}${PATH_SEP}$ENV{PYTHONPATH}" "MPLBACKEND=agg"
   )

# This macro runs a Python test
macro (ot_pyinstallcheck_test TESTNAME)
  set (TEST_TARGET t_${TESTNAME})
  set (TESTNAME_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_TARGET}.py)

  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    if (${_ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    endif ()
  endforeach ()

  if (_IGNOREOUT)
    add_test (NAME pyinstallcheck_${TESTNAME} COMMAND ${Python_EXECUTABLE} ${TESTNAME_LOC})
  else ()
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_TARGET}.expout)
    if (NOT EXISTS ${OUTFILE_LOC})
      message (SEND_ERROR "Missing file ${OUTFILE_LOC}")
    endif ()
    add_test (NAME pyinstallcheck_${TESTNAME} COMMAND "sh" "-c" "(${Python_EXECUTABLE} ${TESTNAME_LOC} > ${CMAKE_CURRENT_BINARY_DIR}/${TEST_TARGET}.out) && diff -u --strip-trailing-cr ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TEST_TARGET}.out")
  endif ()

  set_tests_properties (pyinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${PYINSTALLCHECK_ENVIRONMENT}")
endmacro ()


# Use cases
ot_pyinstallcheck_test (ackley_function IGNOREOUT)
ot_pyinstallcheck_test (branin_function IGNOREOUT)
ot_pyinstallcheck_test (cantilever_beam IGNOREOUT)
ot_pyinstallcheck_test (coles IGNOREOUT)
ot_pyinstallcheck_test (chaboche_model IGNOREOUT)
ot_pyinstallcheck_test (deflection_tube IGNOREOUT)
ot_pyinstallcheck_test (flood_model IGNOREOUT)
ot_pyinstallcheck_test (ishigami_function IGNOREOUT)
ot_pyinstallcheck_test (logistic_model IGNOREOUT)
ot_pyinstallcheck_test (stressed_beam IGNOREOUT)
ot_pyinstallcheck_test (fire_satellite IGNOREOUT)
ot_pyinstallcheck_test (wingweight_function IGNOREOUT)
ot_pyinstallcheck_test (oscillator IGNOREOUT)
ot_pyinstallcheck_test (stiffened_panel IGNOREOUT)
if (NUMPY_FOUND)
  ot_pyinstallcheck_test (viscous_free_fall IGNOREOUT)
endif()

# Common
ot_pyinstallcheck_test (Object_std IGNOREOUT)
if (LIBXML2_FOUND)
  ot_pyinstallcheck_test (Object_pickle)
endif ()
ot_pyinstallcheck_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
  ot_pyinstallcheck_test (Study_saveload)
  ot_pyinstallcheck_test (Study_std IGNOREOUT)
  if (HDF5_FOUND)
    ot_pyinstallcheck_test (Study_h5 IGNOREOUT)
  endif ()
endif ()
ot_pyinstallcheck_test (Path_std IGNOREOUT)
ot_pyinstallcheck_test (ResourceMap_std IGNOREOUT)

# Type
ot_pyinstallcheck_test (Collection_std)
ot_pyinstallcheck_test (Description_std)
ot_pyinstallcheck_test (Indices_std)
ot_pyinstallcheck_test (IndicesCollection_std)
ot_pyinstallcheck_test (Point_std)
ot_pyinstallcheck_test (Point_description)
ot_pyinstallcheck_test (Matrix_std)
ot_pyinstallcheck_test (SymmetricMatrix_lapack)
ot_pyinstallcheck_test (SquareMatrix_lapack)
ot_pyinstallcheck_test (SquareMatrix_std)
ot_pyinstallcheck_test (TriangularMatrix_std)
ot_pyinstallcheck_test (SymmetricMatrix_std)
ot_pyinstallcheck_test (Tensor_std)
ot_pyinstallcheck_test (ComplexTensor_std)
ot_pyinstallcheck_test (SymmetricTensor_std)
ot_pyinstallcheck_test (Matrix_solve)
ot_pyinstallcheck_test (Matrix_decomposition)
ot_pyinstallcheck_test (IdentityMatrix_std)
ot_pyinstallcheck_test (RegularGrid_std)
ot_pyinstallcheck_test (ComplexMatrix_std)
ot_pyinstallcheck_test (SquareComplexMatrix_std)
ot_pyinstallcheck_test (HermitianMatrix_std)
ot_pyinstallcheck_test (TriangularComplexMatrix_std)
ot_pyinstallcheck_test (Matrix_slice)
ot_pyinstallcheck_test (Matrix_operators)
if (NUMPY_FOUND)
  ot_pyinstallcheck_test (Matrix_numpy)
endif ()

# Func
ot_pyinstallcheck_test (SpecFunc_std)
ot_pyinstallcheck_test (Function_std)
ot_pyinstallcheck_test (Function_linearity IGNOREOUT)
ot_pyinstallcheck_test (ComposedFunction_std)
ot_pyinstallcheck_test (Function_python IGNOREOUT)
if (LIBXML2_FOUND)
ot_pyinstallcheck_test (Function_python_saveload)
endif ()
ot_pyinstallcheck_test (DatabaseFunction_std)
ot_pyinstallcheck_test (Function_operations)
ot_pyinstallcheck_test (ParametricFunction_std)
ot_pyinstallcheck_test (IdentityFunction_std IGNOREOUT)
ot_pyinstallcheck_test (Function_draw)
ot_pyinstallcheck_test (MemoizeFunction_std)
ot_pyinstallcheck_test (AggregatedEvaluation_std)
if (OPENTURNS_HAVE_EXPRTK)
ot_pyinstallcheck_test (SymbolicEvaluation_std)
ot_pyinstallcheck_test (SymbolicGradient_std)
ot_pyinstallcheck_test (SymbolicHessian_std)
ot_pyinstallcheck_test (SymbolicFunction_std)
endif ()
if (OPENTURNS_HAVE_MUPARSER)
ot_pyinstallcheck_test (SymbolicEvaluation_muparser)
ot_pyinstallcheck_test (SymbolicGradient_muparser)
ot_pyinstallcheck_test (SymbolicHessian_muparser)
ot_pyinstallcheck_test (SymbolicFunction_muparser)
endif ()
ot_pyinstallcheck_test (TranslationFunction_std)
ot_pyinstallcheck_test (LinearFunction_std)
ot_pyinstallcheck_test (LinearEvaluation_std)
ot_pyinstallcheck_test (LinearCombinationEvaluation_std)
ot_pyinstallcheck_test (LinearCombinationGradient_std)
ot_pyinstallcheck_test (LinearCombinationHessian_std)
ot_pyinstallcheck_test (PiecewiseLinearEvaluation_std)
ot_pyinstallcheck_test (PiecewiseHermiteEvaluation_std)
ot_pyinstallcheck_test (QuadraticFunction_std)
ot_pyinstallcheck_test (QuadraticEvaluation_std)
ot_pyinstallcheck_test (LinearGradient_std)
ot_pyinstallcheck_test (AggregatedFunction_std)
ot_pyinstallcheck_test (DualLinearCombinationFunction_std)
ot_pyinstallcheck_test (IndicatorFunction_std IGNOREOUT)
ot_pyinstallcheck_test (DistanceToDomainFunction_std IGNOREOUT)
ot_pyinstallcheck_test (LinearCombinationFunction_std)
ot_pyinstallcheck_test (ConstantGradient_std)
ot_pyinstallcheck_test (ConstantHessian_std)
ot_pyinstallcheck_test (ConstantFunction_std IGNOREOUT)
ot_pyinstallcheck_test (Basis_std IGNOREOUT)
ot_pyinstallcheck_test (BasisSequence_std)
ot_pyinstallcheck_test (LARS_std)
ot_pyinstallcheck_test (LARS_noisy_error IGNOREOUT)
ot_pyinstallcheck_test (FieldFunction_std)
ot_pyinstallcheck_test (FieldFunction_python)
ot_pyinstallcheck_test (ValueFunction_std)
ot_pyinstallcheck_test (VertexValueFunction_std)
ot_pyinstallcheck_test (FieldToPointFunction_std)
ot_pyinstallcheck_test (FieldToPointFunction_python)
ot_pyinstallcheck_test (PointToFieldFunction_std)
ot_pyinstallcheck_test (PointToFieldFunction_python)
if (LIBXML2_FOUND AND DILL_FOUND)
  ot_pyinstallcheck_test (PythonPointToFieldFunction_save IGNOREOUT)
  ot_pyinstallcheck_test (PythonPointToFieldFunction_load IGNOREOUT)
  set_tests_properties(pyinstallcheck_PythonPointToFieldFunction_load
    PROPERTIES DEPENDS pyinstallcheck_PythonPointToFieldFunction_save)
endif ()
ot_pyinstallcheck_test (ParametricPointToFieldFunction_std)
ot_pyinstallcheck_test (VertexValuePointToFieldFunction_std)
ot_pyinstallcheck_test (VertexFieldToPointFunction_std IGNOREOUT)
ot_pyinstallcheck_test (BoxCoxEvaluation_std)
ot_pyinstallcheck_test (BoxCoxTransform_std)
ot_pyinstallcheck_test (InverseBoxCoxEvaluation_std)
ot_pyinstallcheck_test (InverseBoxCoxTransform_std)
ot_pyinstallcheck_test (TrendEvaluation_std)
ot_pyinstallcheck_test (TrendTransform_std)
ot_pyinstallcheck_test (InverseTrendEvaluation_std)
ot_pyinstallcheck_test (InverseTrendTransform_std)
ot_pyinstallcheck_test (ExpertMixture_std)
ot_pyinstallcheck_test (UniVariatePolynomial_std)
ot_pyinstallcheck_test (BasisFactory_std)
ot_pyinstallcheck_test (Field_std)
ot_pyinstallcheck_test (MonomialFunction_std)
ot_pyinstallcheck_test (MonomialFunctionFactory_std)
ot_pyinstallcheck_test (TensorizedUniVariateFunctionFactory_std)
ot_pyinstallcheck_test (PointToPointEvaluation_std)
ot_pyinstallcheck_test (PointToPointConnection_std)
ot_pyinstallcheck_test (PointToFieldConnection_std)
ot_pyinstallcheck_test (FieldToPointConnection_std)
ot_pyinstallcheck_test (FieldToFieldConnection_std)
if (NOT MINGW)
  ot_pyinstallcheck_test (PythonFunction_multiprocessing IGNOREOUT)
endif ()
if (LIBXML2_FOUND AND DILL_FOUND)
  ot_pyinstallcheck_test (PythonFunction_save IGNOREOUT)
  ot_pyinstallcheck_test (PythonFunction_load IGNOREOUT)
  set_tests_properties(pyinstallcheck_PythonFunction_load
    PROPERTIES DEPENDS pyinstallcheck_PythonFunction_save)
endif ()

# Stat
ot_pyinstallcheck_test (Sample_std)
ot_pyinstallcheck_test (Sample_computation)
ot_pyinstallcheck_test (Sample_slice)
ot_pyinstallcheck_test (Sample_split)
ot_pyinstallcheck_test (Sample_large)
ot_pyinstallcheck_test (Sample_bug14)
ot_pyinstallcheck_test (Sample_csv)
ot_pyinstallcheck_test (Sample_operators)
if (PANDAS_FOUND)
  ot_pyinstallcheck_test (Sample_pandas IGNOREOUT)
endif ()
ot_pyinstallcheck_test (SamplePartition_std IGNOREOUT)
ot_pyinstallcheck_test (HistoryStrategy_std)
ot_pyinstallcheck_test (CovarianceMatrix_std)
ot_pyinstallcheck_test (CorrelationMatrix_std)
ot_pyinstallcheck_test (CorrelationAnalysis_std IGNOREOUT)
ot_pyinstallcheck_test (Field_draw)
ot_pyinstallcheck_test (ProcessSample_std)
ot_pyinstallcheck_test (RandomGenerator_std)
ot_pyinstallcheck_test (SobolSequence_std IGNOREOUT)
ot_pyinstallcheck_test (FaureSequence_std IGNOREOUT)
ot_pyinstallcheck_test (HaltonSequence_std IGNOREOUT)
ot_pyinstallcheck_test (HaselgroveSequence_std)
ot_pyinstallcheck_test (ReverseHaltonSequence_std)
ot_pyinstallcheck_test (TestResult_std)
ot_pyinstallcheck_test (TimeSeries_std)
ot_pyinstallcheck_test (FilteringWindows_std)
ot_pyinstallcheck_test (WelchFactory_std)
ot_pyinstallcheck_test (ExponentialModel_std)
ot_pyinstallcheck_test (CovarianceModel_std IGNOREOUT)
ot_pyinstallcheck_test (ExponentiallyDampedCosineModel_std)
ot_pyinstallcheck_test (CauchyModel_std)
ot_pyinstallcheck_test (UserDefinedSpectralModel_std)
ot_pyinstallcheck_test (UserDefinedCovarianceModel_std)
ot_pyinstallcheck_test (UserDefinedStationaryCovarianceModel_std)
ot_pyinstallcheck_test (StationaryCovarianceModelFactory_std)
ot_pyinstallcheck_test (NonStationaryCovarianceModelFactory_std)
ot_pyinstallcheck_test (ProductCovarianceModel_std)
ot_pyinstallcheck_test (StationaryFunctionalCovarianceModel_std IGNOREOUT)
ot_pyinstallcheck_test (LatentVariableModel_std IGNOREOUT)
ot_pyinstallcheck_test (ProcessSample_operators IGNOREOUT)
ot_pyinstallcheck_test (Field_operators IGNOREOUT)

if (HMAT_FOUND)
ot_pyinstallcheck_test (HMatrix_std)
endif ()

# Geom
ot_pyinstallcheck_test (Domain_std)
ot_pyinstallcheck_test (Interval_std)
ot_pyinstallcheck_test (IntervalMesher_std)
ot_pyinstallcheck_test (LevelSet_std)
ot_pyinstallcheck_test (LevelSetMesher_std)
ot_pyinstallcheck_test (Mesh_std)
ot_pyinstallcheck_test (Mesh_draw IGNOREOUT)
ot_pyinstallcheck_test (BoundaryMesher_std IGNOREOUT)
ot_pyinstallcheck_test (DomainComplement_std)
ot_pyinstallcheck_test (DomainDifference_std)
ot_pyinstallcheck_test (DomainIntersection_std)
ot_pyinstallcheck_test (DomainUnion_std)
ot_pyinstallcheck_test (DomainDisjunctiveUnion_std)

## Graph
ot_pyinstallcheck_test (BarPlot_std)
ot_pyinstallcheck_test (Cloud_std)
ot_pyinstallcheck_test (Contour_std)
ot_pyinstallcheck_test (Curve_std)
ot_pyinstallcheck_test (Drawable_std)
ot_pyinstallcheck_test (Graph_mix)
ot_pyinstallcheck_test (Pie_std)
ot_pyinstallcheck_test (Polygon_std)
ot_pyinstallcheck_test (PolygonArray_std)
ot_pyinstallcheck_test (Staircase_std)
ot_pyinstallcheck_test (Text_std)
ot_pyinstallcheck_test (GridLayout_std IGNOREOUT)

## Diff
ot_pyinstallcheck_test (FiniteDifferenceStep_std)
ot_pyinstallcheck_test (CenteredFiniteDifferenceGradient_std)
ot_pyinstallcheck_test (CenteredFiniteDifferenceHessian_std)
ot_pyinstallcheck_test (NonCenteredFiniteDifferenceGradient_std)

## Optim
ot_pyinstallcheck_test (AbdoRackwitz_std IGNOREOUT)
if (Bonmin_FOUND)
  ot_pyinstallcheck_test (Bonmin_std IGNOREOUT)
  ot_pyinstallcheck_test (Bonmin_4dsoo IGNOREOUT)
  ot_pyinstallcheck_test (Bonmin_MIT15 IGNOREOUT)
  ot_pyinstallcheck_test (Bonmin_swiler2014 IGNOREOUT)
endif ()
if (Ipopt_FOUND)
  ot_pyinstallcheck_test (Ipopt_std IGNOREOUT)
endif ()
if (Ceres_FOUND)
  ot_pyinstallcheck_test (Ceres_std IGNOREOUT)
endif ()
if (CMinpack_FOUND)

=== lib/src/Base/MetaModel/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (LinearTaylor.cxx)
ot_add_source_file (QuadraticTaylor.cxx)
ot_add_source_file (LinearLeastSquares.cxx)
ot_add_source_file (QuadraticLeastSquares.cxx)
ot_add_source_file (MetaModelResult.cxx)

ot_install_header_file (OTBaseMetaModel.hxx)
ot_install_header_file (LinearTaylor.hxx)
ot_install_header_file (QuadraticTaylor.hxx)
ot_install_header_file (LinearLeastSquares.hxx)
ot_install_header_file (QuadraticLeastSquares.hxx)
ot_install_header_file (MetaModelResult.hxx)

=== lib/src/Base/Optim/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (AbdoRackwitz.cxx)
ot_add_source_file (algocobyla.c)
ot_add_source_file (Bonmin.cxx)
ot_add_source_file (Ceres.cxx)
ot_add_source_file (CMinpack.cxx)
ot_add_source_file (Cobyla.cxx)
if (OPENTURNS_HAVE_BONMIN)
  ot_add_source_file (BonminProblem.cxx)
endif ()
ot_add_source_file (Dlib.cxx)
if (dlib_FOUND)
  ot_add_source_file (DlibFunctions.cxx)
endif()
ot_add_source_file (HiGHS.cxx)
if (OPENTURNS_HAVE_IPOPT)
  ot_add_source_file (IpoptProblem.cxx)
endif()
ot_add_source_file (Ipopt.cxx)
ot_add_source_file (MultiStart.cxx)
ot_add_source_file (NearestPointChecker.cxx)
ot_add_source_file (NearestPointCheckerResult.cxx)
ot_add_source_file (NLopt.cxx)
ot_add_source_file (OptimizationProblem.cxx)
ot_add_source_file (OptimizationProblemImplementation.cxx)
ot_add_source_file (OptimizationAlgorithm.cxx)
ot_add_source_file (OptimizationAlgorithmImplementation.cxx)
ot_add_source_file (NearestPointProblem.cxx)
ot_add_source_file (LeastSquaresProblem.cxx)
ot_add_source_file (LinearProblem.cxx)
ot_add_source_file (OptimizationResult.cxx)
ot_add_source_file (SQP.cxx)
ot_add_source_file (algotnc.c)
ot_add_source_file (TNC.cxx)
ot_add_source_file (Pagmo.cxx)

ot_install_header_file (OTOptim.hxx)
ot_install_header_file (AbdoRackwitz.hxx)
ot_install_header_file (Bonmin.hxx)
ot_install_header_file (Ceres.hxx)
ot_install_header_file (CMinpack.hxx)
ot_install_header_file (Cobyla.hxx)
ot_install_header_file (Dlib.hxx)
ot_install_header_file (HiGHS.hxx)
ot_install_header_file (Ipopt.hxx)
ot_install_header_file (MultiStart.hxx)
ot_install_header_file (NearestPointChecker.hxx)
ot_install_header_file (NearestPointCheckerResult.hxx)
ot_install_header_file (NLopt.hxx)
ot_install_header_file (OptimizationProblem.hxx)
ot_install_header_file (OptimizationProblemImplementation.hxx)
ot_install_header_file (NearestPointProblem.hxx)
ot_install_header_file (LeastSquaresProblem.hxx)
ot_install_header_file (LinearProblem.hxx)
ot_install_header_file (OptimizationAlgorithm.hxx)
ot_install_header_file (OptimizationAlgorithmImplementation.hxx)
ot_install_header_file (OptimizationResult.hxx)
ot_install_header_file (SQP.hxx)
ot_install_header_file (TNC.hxx)
ot_install_header_file (Pagmo.hxx)

=== lib/src/Uncertainty/Distribution/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (AliMikhailHaqCopula.cxx)
ot_add_source_file (AliMikhailHaqCopulaFactory.cxx)
ot_add_source_file (Arcsine.cxx)
ot_add_source_file (ArcsineFactory.cxx)
ot_add_source_file (ArcsineMuSigma.cxx)
ot_add_source_file (Bernoulli.cxx)
ot_add_source_file (BernoulliFactory.cxx)
ot_add_source_file (BernsteinCopulaFactory.cxx)
ot_add_source_file (Beta.cxx)
ot_add_source_file (BetaFactory.cxx)
ot_add_source_file (BetaMuSigma.cxx)
ot_add_source_file (Binomial.cxx)
ot_add_source_file (BinomialFactory.cxx)
ot_add_source_file (BlockIndependentCopula.cxx)
ot_add_source_file (BlockIndependentDistribution.cxx)
ot_add_source_file (Burr.cxx)
ot_add_source_file (BurrFactory.cxx)
ot_add_source_file (Chi.cxx)
ot_add_source_file (ChiFactory.cxx)
ot_add_source_file (ChiSquare.cxx)
ot_add_source_file (ChiSquareFactory.cxx)
ot_add_source_file (ClaytonCopula.cxx)
ot_add_source_file (ClaytonCopulaFactory.cxx)
ot_add_source_file (CombinationsDistribution.cxx)
ot_add_source_file (CompositeDistribution.cxx)
ot_add_source_file (CompoundDistribution.cxx)
ot_add_source_file (PointConditionalDistribution.cxx)
ot_add_source_file (CumulativeDistributionNetwork.cxx)
ot_add_source_file (Dirac.cxx)
ot_add_source_file (DiracFactory.cxx)
ot_add_source_file (Dirichlet.cxx)
ot_add_source_file (DirichletFactory.cxx)
ot_add_source_file (DiscreteCompoundDistribution.cxx)
ot_add_source_file (DistFunc.cxx)
ot_add_source_file (EmpiricalBernsteinCopula.cxx)
ot_add_source_file (Epanechnikov.cxx)
ot_add_source_file (Exponential.cxx)
ot_add_source_file (ExponentialFactory.cxx)
ot_add_source_file (ExtremeValueCopula.cxx)
ot_add_source_file (JoeCopula.cxx)
ot_add_source_file (FarlieGumbelMorgensternCopula.cxx)
ot_add_source_file (FarlieGumbelMorgensternCopulaFactory.cxx)
ot_add_source_file (FisherSnedecor.cxx)
ot_add_source_file (FisherSnedecorFactory.cxx)
ot_add_source_file (FrankCopula.cxx)
ot_add_source_file (FrankCopulaFactory.cxx)
ot_add_source_file (Frechet.cxx)
ot_add_source_file (FrechetFactory.cxx)
ot_add_source_file (GalambosCopula.cxx)
ot_add_source_file (Gamma.cxx)
ot_add_source_file (GammaFactory.cxx)
ot_add_source_file (GammaMuSigma.cxx)
ot_add_source_file (GeneralizedExtremeValue.cxx)
ot_add_source_file (GeneralizedExtremeValueFactory.cxx)
ot_add_source_file (GeneralizedExtremeValueValidation.cxx)
ot_add_source_file (DistributionFactoryLikelihoodResult.cxx)
ot_add_source_file (ProfileLikelihoodResult.cxx)
ot_add_source_file (TimeVaryingResult.cxx)
ot_add_source_file (CovariatesResult.cxx)
ot_add_source_file (GeneralizedPareto.cxx)
ot_add_source_file (GeneralizedParetoFactory.cxx)
ot_add_source_file (GeneralizedParetoValidation.cxx)
ot_add_source_file (Geometric.cxx)
ot_add_source_file (GeometricFactory.cxx)
ot_add_source_file (GumbelCopula.cxx)
ot_add_source_file (GumbelCopulaFactory.cxx)
ot_add_source_file (Gumbel.cxx)
ot_add_source_file (GumbelFactory.cxx)
ot_add_source_file (GumbelLambdaGamma.cxx)
ot_add_source_file (GumbelMuSigma.cxx)
ot_add_source_file (Histogram.cxx)
ot_add_source_file (HistogramFactory.cxx)
ot_add_source_file (Hypergeometric.cxx)
ot_add_source_file (IndependentCopula.cxx)
ot_add_source_file (IndependentCopulaFactory.cxx)
ot_add_source_file (InverseChiSquare.cxx)
ot_add_source_file (InverseGamma.cxx)
ot_add_source_file (InverseNormal.cxx)
ot_add_source_file (InverseNormalFactory.cxx)
ot_add_source_file (InverseWishart.cxx)
ot_add_source_file (JointByConditioningDistribution.cxx)
ot_add_source_file (JointDistribution.cxx)
ot_add_source_file (KFactorFunctions.cxx)
ot_add_source_file (KPermutationsDistribution.cxx)
ot_add_source_file (KernelMixture.cxx)
ot_add_source_file (KernelSmoothing.cxx)
ot_add_source_file (KolmogorovFunctions.cxx)

# borrowed from https://github.com/scipy/scipy/tree/main/scipy/special/special/cephes
ot_add_build_dir_to_include_dirs(${CMAKE_CURRENT_SOURCE_DIR}/cephes)

ot_add_source_file (Laplace.cxx)
ot_add_source_file (LaplaceFactory.cxx)
ot_add_source_file (LeastSquaresDistributionFactory.cxx)
ot_add_source_file (Logistic.cxx)
ot_add_source_file (LogisticFactory.cxx)
ot_add_source_file (LogNormal.cxx)
ot_add_source_file (LogNormalFactory.cxx)
ot_add_source_file (LogNormalMuErrorFactor.cxx)
ot_add_source_file (LogNormalMuSigma.cxx)
ot_add_source_file (LogNormalMuSigmaOverMu.cxx)
ot_add_source_file (LogUniform.cxx)
ot_add_source_file (LogUniformFactory.cxx)
ot_add_source_file (MarshallOlkinCopula.cxx)
ot_add_source_file (MarginalDistribution.cxx)
ot_add_source_file (MarginalUniformOrderStatistics.cxx)
ot_add_source_file (MaximumDistribution.cxx)
ot_add_source_file (MaximumEntropyOrderStatisticsDistribution.cxx)
ot_add_source_file (MaximumLikelihoodFactory.cxx)
ot_add_source_file (MeixnerDistribution.cxx)
ot_add_source_file (MeixnerDistributionFactory.cxx)
ot_add_source_file (MethodOfMomentsFactory.cxx)
ot_add_source_file (MinCopula.cxx)
ot_add_source_file (MixedHistogramUserDefined.cxx)
ot_add_source_file (Mixture.cxx)
ot_add_source_file (Multinomial.cxx)
ot_add_source_file (MultinomialFactory.cxx)
ot_add_source_file (Polya.cxx)
ot_add_source_file (PolyaFactory.cxx)
ot_add_source_file (NonCentralChiSquare.cxx)
ot_add_source_file (NonCentralStudent.cxx)
ot_add_source_file (Normal2DCDF.cxx)
ot_add_source_file (Normal3DCDF.cxx)
ot_add_source_file (NormalCopula.cxx)
ot_add_source_file (NormalCopulaFactory.cxx)
ot_add_source_file (Normal.cxx)
ot_add_source_file (NormalFactory.cxx)
ot_add_source_file (NormalGamma.cxx)
ot_add_source_file (OrderStatisticsMarginalChecker.cxx)
ot_add_source_file (OrdinalSumCopula.cxx)
ot_add_source_file (ParametrizedDistribution.cxx)
ot_add_source_file (Pareto.cxx)
ot_add_source_file (ParetoFactory.cxx)
ot_add_source_file (PlackettCopula.cxx)
ot_add_source_file (PlackettCopulaFactory.cxx)
ot_add_source_file (Poisson.cxx)
ot_add_source_file (PoissonFactory.cxx)
ot_add_source_file (PosteriorDistribution.cxx)
ot_add_source_file (ProductDistribution.cxx)
ot_add_source_file (QuantileMatchingFactory.cxx)
ot_add_source_file (RandomMixture.cxx)
ot_add_source_file (Rayleigh.cxx)
ot_add_source_file (RayleighFactory.cxx)
ot_add_source_file (Rice.cxx)
ot_add_source_file (RiceFactory.cxx)
ot_add_source_file (Skellam.cxx)
ot_add_source_file (SkellamFactory.cxx)
ot_add_source_file (SmoothedUniform.cxx)
ot_add_source_file (SmoothedUniformFactory.cxx)
ot_add_source_file (SquaredNormal.cxx)
ot_add_source_file (Student.cxx)
ot_add_source_file (StudentCopula.cxx)
ot_add_source_file (StudentCopulaFactory.cxx)
ot_add_source_file (StudentFunctions.cxx)
ot_add_source_file (StudentFactory.cxx)
ot_add_source_file (Trapezoidal.cxx)
ot_add_source_file (TrapezoidalFactory.cxx)
ot_add_source_file (Triangular.cxx)
ot_add_source_file (TriangularFactory.cxx)
ot_add_source_file (TruncatedDistribution.cxx)
ot_add_source_file (TruncatedNormal.cxx)
ot_add_source_file (TruncatedNormalFactory.cxx)
ot_add_source_file (TruncatedOverMesh.cxx)
ot_add_source_file (Uniform.cxx)
ot_add_source_file (UniformOverMesh.cxx)
ot_add_source_file (UniformOrderStatistics.cxx)
ot_add_source_file (UniformFactory.cxx)
ot_add_source_file (UniformMuSigma.cxx)
ot_add_source_file (UserDefined.cxx)
ot_add_source_file (UserDefinedFactory.cxx)
ot_add_source_file (VonMises.cxx)
ot_add_source_file (VonMisesFactory.cxx)
ot_add_source_file (WeibullMax.cxx)
ot_add_source_file (WeibullMaxFactory.cxx)
ot_add_source_file (WeibullMaxMuSigma.cxx)
ot_add_source_file (WeibullMin.cxx)
ot_add_source_file (WeibullMinFactory.cxx)
ot_add_source_file (WeibullMinMuSigma.cxx)
ot_add_source_file (Wishart.cxx)
ot_add_source_file (ZipfMandelbrot.cxx)

ot_install_header_file (AliMikhailHaqCopula.hxx)
ot_install_header_file (AliMikhailHaqCopulaFactory.hxx)
ot_install_header_file (Arcsine.hxx)
ot_install_header_file (ArcsineFactory.hxx)
ot_install_header_file (ArcsineMuSigma.hxx)
ot_install_header_file (Bernoulli.hxx)
ot_install_header_file (BernoulliFactory.hxx)
ot_install_header_file (BernsteinCopulaFactory.hxx)
ot_install_header_file (Beta.hxx)
ot_install_header_file (BetaFactory.hxx)
ot_install_header_file (BetaMuSigma.hxx)
ot_install_header_file (Binomial.hxx)
ot_install_header_file (BinomialFactory.hxx)
ot_install_header_file (BlockIndependentCopula.hxx)
ot_install_header_file (BlockIndependentDistribution.hxx)
ot_install_header_file (Burr.hxx)
ot_install_header_file (BurrFactory.hxx)
ot_install_header_file (Chi.hxx)
ot_install_header_file (ChiFactory.hxx)
ot_install_header_file (ChiSquare.hxx)
ot_install_header_file (ChiSquareFactory.hxx)
ot_install_header_file (ClaytonCopula.hxx)
ot_install_header_file (ClaytonCopulaFactory.hxx)
ot_install_header_file (CombinationsDistribution.hxx)
ot_install_header_file (CompositeDistribution.hxx)
ot_install_header_file (CompoundDistribution.hxx)
ot_install_header_file (PointConditionalDistribution.hxx)
ot_install_header_file (CumulativeDistributionNetwork.hxx)
ot_install_header_file (DiracFactory.hxx)
ot_install_header_file (Dirac.hxx)
ot_install_header_file (DirichletFactory.hxx)
ot_install_header_file (Dirichlet.hxx)
ot_install_header_file (DiscreteCompoundDistribution.hxx)
ot_install_header_file (DistFunc.hxx)
ot_install_header_file (EmpiricalBernsteinCopula.hxx)
ot_install_header_file (Epanechnikov.hxx)
ot_install_header_file (ExponentialFactory.hxx)
ot_install_header_file (Exponential.hxx)
ot_install_header_file (ExtremeValueCopula.hxx)
ot_install_header_file (JoeCopula.hxx)
ot_install_header_file (FarlieGumbelMorgensternCopula.hxx)
ot_install_header_file (FarlieGumbelMorgensternCopulaFactory.hxx)
ot_install_header_file (FisherSnedecor.hxx)
ot_install_header_file (FisherSnedecorFactory.hxx)
ot_install_header_file (FrankCopula.hxx)
ot_install_header_file (FrankCopulaFactory.hxx)
ot_install_header_file (Frechet.hxx)
ot_install_header_file (FrechetFactory.hxx)
ot_install_header_file (GalambosCopula.hxx)
ot_install_header_file (GammaFactory.hxx)
ot_install_header_file (Gamma.hxx)
ot_install_header_file (GammaMuSigma.hxx)
ot_install_header_file (GeneralizedExtremeValue.hxx)
ot_install_header_file (GeneralizedExtremeValueFactory.hxx)
ot_install_header_file (GeneralizedExtremeValueValidation.hxx)
ot_install_header_file (DistributionFactoryLikelihoodResult.hxx)
ot_install_header_file (ProfileLikelihoodResult.hxx)
ot_install_header_file (TimeVaryingResult.hxx)
ot_install_header_file (CovariatesResult.hxx)
ot_install_header_file (GeneralizedPareto.hxx)
ot_install_header_file (GeneralizedParetoFactory.hxx)
ot_install_header_file (GeneralizedParetoValidation.hxx)
ot_install_header_file (GeometricFactory.hxx)
ot_install_header_file (Geometric.hxx)
ot_install_header_file (GumbelCopulaFactory.hxx)
ot_install_header_file (GumbelCopula.hxx)
ot_install_header_file (GumbelFactory.hxx)
ot_install_header_file (Gumbel.hxx)
ot_install_header_file (GumbelLambdaGamma.hxx)
ot_install_header_file (GumbelMuSigma.hxx)
ot_install_header_file (HistogramFactory.hxx)
ot_install_header_file (Histogram.hxx)
ot_install_header_file (Hypergeometric.hxx)
ot_install_header_file (IndependentCopula.hxx)
ot_install_header_file (IndependentCopulaFactory.hxx)
ot_install_header_file (InverseChiSquare.hxx)
ot_install_header_file (InverseGamma.hxx)
ot_install_header_file (InverseNormal.hxx)
ot_install_header_file (InverseNormalFactory.hxx)
ot_install_header_file (InverseWishart.hxx)
ot_install_header_file (JointByConditioningDistribution.hxx)
ot_install_header_file (JointDistribution.hxx)
ot_install_header_file (KFactorFunctions.hxx)
ot_install_header_file (KPermutationsDistribution.hxx)
ot_install_header_file (KernelMixture.hxx)
ot_install_header_file (KernelSmoothing.hxx)
ot_install_header_file (LaplaceFactory.hxx)
ot_install_header_file (Laplace.hxx)
ot_install_header_file (LeastSquaresDistributionFactory.hxx)
ot_install_header_file (LogisticFactory.hxx)
ot_install_header_file (Logistic.hxx)
ot_install_header_file (LogNormalFactory.hxx)
ot_install_header_file (LogNormal.hxx)

=== lib/src/Uncertainty/Model/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (Distribution.cxx)
ot_add_source_file (DistributionImplementation.cxx)
ot_add_source_file (EllipticalDistribution.cxx)
ot_add_source_file (SklarCopula.cxx)
ot_add_source_file (ArchimedeanCopula.cxx)
ot_add_source_file (RandomVector.cxx)
ot_add_source_file (RandomVectorImplementation.cxx)
ot_add_source_file (CompoundRandomVector.cxx)
ot_add_source_file (ConstantRandomVector.cxx)
ot_add_source_file (CompositeRandomVector.cxx)
ot_add_source_file (FunctionalChaosRandomVector.cxx)
ot_add_source_file (KrigingRandomVector.cxx)
ot_add_source_file (UsualRandomVector.cxx)
ot_add_source_file (DomainEvent.cxx)
ot_add_source_file (ThresholdEvent.cxx)
ot_add_source_file (ThresholdEventImplementation.cxx)
ot_add_source_file (ProcessEvent.cxx)
ot_add_source_file (IntersectionEvent.cxx)
ot_add_source_file (StandardEvent.cxx)
ot_add_source_file (UnionEvent.cxx)
ot_add_source_file (DistributionFactoryResult.cxx)
ot_add_source_file (DistributionFactory.cxx)
ot_add_source_file (DistributionFactoryImplementation.cxx)
ot_add_source_file (ProcessImplementation.cxx)
ot_add_source_file (Process.cxx)
ot_add_source_file (DistributionParametersImplementation.cxx)
ot_add_source_file (DistributionParameters.cxx)
ot_add_source_file (RatioOfUniforms.cxx)
ot_add_source_file(GaussianProcessRandomVector.cxx)

ot_install_header_file (RandomVectorImplementation.hxx)
ot_install_header_file (SklarCopula.hxx)
ot_install_header_file (RandomVector.hxx)
ot_install_header_file (EllipticalDistribution.hxx)
ot_install_header_file (CompositeRandomVector.hxx)
ot_install_header_file (CompoundRandomVector.hxx)
ot_install_header_file (DistributionFactoryResult.hxx)
ot_install_header_file (DistributionFactory.hxx)
ot_install_header_file (DistributionImplementation.hxx)
ot_install_header_file (FunctionalChaosRandomVector.hxx)
ot_install_header_file (KrigingRandomVector.hxx)
ot_install_header_file (UsualRandomVector.hxx)
ot_install_header_file (StandardEvent.hxx)
ot_install_header_file (UnionEvent.hxx)
ot_install_header_file (Distribution.hxx)
ot_install_header_file (DomainEvent.hxx)
ot_install_header_file (ThresholdEvent.hxx)
ot_install_header_file (ThresholdEventImplementation.hxx)
ot_install_header_file (ProcessEvent.hxx)
ot_install_header_file (IntersectionEvent.hxx)
ot_install_header_file (ArchimedeanCopula.hxx)
ot_install_header_file (DistributionFactoryImplementation.hxx)
ot_install_header_file (ConstantRandomVector.hxx)
ot_install_header_file (OTModel.hxx)
ot_install_header_file (ProcessImplementation.hxx)
ot_install_header_file (Process.hxx)
ot_install_header_file (DistributionParametersImplementation.hxx)
ot_install_header_file (DistributionParameters.hxx)
ot_install_header_file (RatioOfUniforms.hxx)
ot_install_header_file (GaussianProcessRandomVector.hxx)

=== lib/src/Uncertainty/Algorithm/MetaModel/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (MetaModelAlgorithm.cxx)
ot_add_source_file (MetaModelValidation.cxx)

ot_install_header_file (MetaModelAlgorithm.hxx)
ot_install_header_file (MetaModelValidation.hxx)

ot_install_header_file (OTMetaModel.hxx)

# Recurse in subdirectories
add_subdirectory (FunctionalChaos)
add_subdirectory (Kriging)
add_subdirectory (LinearModel)

=== lib/src/Uncertainty/Algorithm/OrthogonalBasis/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (OrthogonalUniVariatePolynomial.cxx)
ot_add_source_file (CharlierFactory.cxx)
ot_add_source_file (ChebychevFactory.cxx)
ot_add_source_file (HermiteFactory.cxx)
ot_add_source_file (HistogramPolynomialFactory.cxx)
ot_add_source_file (JacobiFactory.cxx)
ot_add_source_file (KrawtchoukFactory.cxx)
ot_add_source_file (LaguerreFactory.cxx)
ot_add_source_file (LegendreFactory.cxx)
ot_add_source_file (MeixnerFactory.cxx)
ot_add_source_file (OrthogonalFunctionFactory.cxx)
ot_add_source_file (OrthogonalProductPolynomialFactory.cxx)
ot_add_source_file (OrthogonalUniVariatePolynomialFactory.cxx)
ot_add_source_file (OrthogonalUniVariatePolynomialFamily.cxx)
ot_add_source_file (OrthonormalizationAlgorithm.cxx)
ot_add_source_file (OrthonormalizationAlgorithmImplementation.cxx)
ot_add_source_file (AdaptiveStieltjesAlgorithm.cxx)
ot_add_source_file (StandardDistributionPolynomialFactory.cxx)
ot_add_source_file (OrthogonalBasis.cxx)
ot_add_source_file (OrthogonalUniVariateFunctionFamily.cxx)
ot_add_source_file (OrthogonalUniVariateFunctionFactory.cxx)
ot_add_source_file (OrthogonalUniVariatePolynomialFunctionFactory.cxx)
ot_add_source_file (FourierSeriesFactory.cxx)
ot_add_source_file (HaarWaveletFactory.cxx)
ot_add_source_file (OrthogonalProductFunctionFactory.cxx)
ot_add_source_file (SoizeGhanemFactory.cxx)
ot_add_source_file (FiniteOrthogonalFunctionFactory.cxx)

ot_install_header_file (OTOrthogonalBasis.hxx)
ot_install_header_file (OrthogonalFunctionFactory.hxx)
ot_install_header_file (OrthogonalUniVariatePolynomialFactory.hxx)
ot_install_header_file (OrthogonalProductPolynomialFactory.hxx)
ot_install_header_file (StandardDistributionPolynomialFactory.hxx)
ot_install_header_file (OrthogonalBasis.hxx)
ot_install_header_file (OrthogonalUniVariatePolynomial.hxx)
ot_install_header_file (OrthonormalizationAlgorithm.hxx)
ot_install_header_file (OrthogonalUniVariatePolynomialFamily.hxx)
ot_install_header_file (AdaptiveStieltjesAlgorithm.hxx)
ot_install_header_file (OrthonormalizationAlgorithmImplementation.hxx)
ot_install_header_file (CharlierFactory.hxx)
ot_install_header_file (ChebychevFactory.hxx)
ot_install_header_file (HermiteFactory.hxx)
ot_install_header_file (HistogramPolynomialFactory.hxx)
ot_install_header_file (JacobiFactory.hxx)
ot_install_header_file (KrawtchoukFactory.hxx)
ot_install_header_file (LaguerreFactory.hxx)
ot_install_header_file (LegendreFactory.hxx)
ot_install_header_file (MeixnerFactory.hxx)
ot_install_header_file (OrthogonalUniVariateFunctionFamily.hxx)
ot_install_header_file (OrthogonalUniVariateFunctionFactory.hxx)
ot_install_header_file (OrthogonalUniVariatePolynomialFunctionFactory.hxx)
ot_install_header_file (FourierSeriesFactory.hxx)
ot_install_header_file (HaarWaveletFactory.hxx)
ot_install_header_file (OrthogonalProductFunctionFactory.hxx)
ot_install_header_file (SoizeGhanemFactory.hxx)
ot_install_header_file (FiniteOrthogonalFunctionFactory.hxx)

=== debian/changelog ===
openturns (1.26-4build1) resolute; urgency=medium

  * No-change rebuild for libdlib20.0.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 08 Jan 2026 09:34:10 +0000

openturns (1.26-4) unstable; urgency=medium

  * Adding B-D on mold on riscv64

 -- Pierre Gruet <pgt@debian.org>  Sat, 13 Dec 2025 22:18:30 +0100

openturns (1.26-3) unstable; urgency=medium

  * Producing less debug symbols and using mold on riscv64 to reduce build
    time, thanks to Adrian Bunk! (Closes: #1122652)

 -- Pierre Gruet <pgt@debian.org>  Sat, 13 Dec 2025 21:39:40 +0100

openturns (1.26-2) unstable; urgency=medium

  * Removing obsolete patch

 -- Pierre Gruet <pgt@debian.org>  Tue, 09 Dec 2025 11:08:02 +0100

openturns (1.26-1) experimental; urgency=medium

  * New upstream version 1.26
  * Bumping SOVERSION to 0.27, new binary package
  * Removing armel-specific stanza in d/rules
  * Rewriting d/watch with version 5
  * Using --output-on-failure and a test timeout, as upstream does
  * Skipping Ceres autopkgtest as Ceres support is currently disabled in
    openturns when Ceres was linked with SuiteSparse GPL components

 -- Pierre Gruet <pgt@debian.org>  Fri, 05 Dec 2025 08:54:43 +0100

=== debian/control ===
Source: openturns
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Pierre Gruet <pgt@debian.org>
Build-Depends: debhelper-compat (= 13),
               bison,
               cmake,
               coinor-libbonmin-dev,
               coinor-libipopt-dev,
               dh-python,
               gfortran,
               flex,
               libblas-dev,
               libboost-math-dev,
               libceres-dev,
               libcminpack-dev,
               libdlib-dev (>= 19.24.4+dfsg),
               libhdf5-dev,
               liblapack-dev,
               libmpc-dev,
               libmpfr-dev,
               libmuparser-dev,
               libnanoflann-dev,
               libnlopt-cxx-dev,
               libpagmo-dev,
               libprimesieve-dev,
               libspectra-dev,
               libtbb-dev,
               libxml2-dev,
               mold [riscv64],
               python3-dev,
               swig
Standards-Version: 4.7.2
Homepage: https://openturns.github.io/www/
Vcs-Browser: https://salsa.debian.org/science-team/openturns
Vcs-Git: https://salsa.debian.org/science-team/openturns.git
Rules-Requires-Root: no

Package: libopenturns0.27
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         openturns-common (= ${source:Version})
Suggests: python3-openturns
Description: dynamic libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * define the outputs of interest and decision criteria;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package provides the dynamic libraries.

Package: libopenturns-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libopenturns0.27 (= ${binary:Version}),
         libceres-dev
Description: headers and development libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package contains development files needed to build OpenTURNS applications.

Package: openturns-common
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: generic tool to treat and quantify uncertainties (common files)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package contains the configuration file for the versioned library
 package.

Package: python3-openturns
Section: python
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libopenturns0.27 (= ${binary:Version}),
         ${python3:Depends}
Provides: ${python3:Provides}
Suggests: python3-matplotlib,
          python3-scipy
Description: Python3 front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package provides the Python3 bindings to the library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/architecture.mk

# Getting the number of jobs for the Debian build to transmit it to CMake.
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	test_makeflags = -j$(NUMJOBS)
endif

# On riscv64, deactivating Dlib-related tests (seems to be a bug in Dlib)
ifeq ($(shell dpkg --print-architecture),riscv64)
    test_discardflags := -E \\\"Dlib_.*|OptimizationAlgorithm_std\\\"
endif

# On loong64, deactivating Dlib tests (seems to be a bug in Dlib)
ifeq ($(shell dpkg --print-architecture),loong64)
    test_discardflags := -E \\\"Dlib_.*|OptimizationAlgorithm_std\\\"
endif

# build time reduction
ifneq (,$(filter $(DEB_HOST_ARCH), alpha riscv64))
    export DEB_CXXFLAGS_MAINT_APPEND += -g1
endif

# mold links faster, but is not yet mature on all architectures
ifneq (,$(filter $(DEB_HOST_ARCH), riscv64))
    export DEB_LDFLAGS_MAINT_APPEND += -fuse-ld=mold
endif

BUILD_DATE = $(shell date --utc --date="@$(SOURCE_DATE_EPOCH)" "+%a, %d %b %Y %H:%M:%S %z")

%:
	dh $@ --buildsystem=cmake --with python3

override_dh_auto_configure:
	dh_auto_configure -Bbuilddir -- \
	        -DUSE_TBB:BOOL=ON \
            -Dot_configure_date:STRING='$(BUILD_DATE)' \
            -DUSE_SPHINX:BOOL=OFF \
            -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_INSTALL_LIBDIR:PATH="/usr/lib/$(DEB_HOST_MULTIARCH)" \
            -DOPENTURNS_PYTHON_MODULE_PATH=lib/python3/dist-packages \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/tmp \
	        -DCMAKE_UNITY_BUILD=ON -DCMAKE_UNITY_BUILD_BATCH_SIZE=32 \
            -DSWIG_COMPILE_FLAGS:STRING='-O1'

override_dh_auto_build:
	$(MAKE) $(test_makeflags) -C builddir/lib
	$(MAKE) -j1 -C builddir/python
	$(MAKE) $(test_makeflags) -C builddir

override_dh_auto_install:
	dh_auto_install -Bbuilddir
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	eval "LD_LIBRARY_PATH=$${LD_LIBRARY_PATH:+$${LD_LIBRARY_PATH}:}$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	  CTEST_OUTPUT_ON_FAILURE=1 \
	  $(MAKE) $(test_makeflags) -C builddir test ARGS=\"$(test_makeflags) $(test_discardflags) -R pyinstallcheck --output-on-failure --timeout 500\""
endif

override_dh_auto_test:
	# 'make test' does not build binary tests
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) $(test_makeflags) -C builddir tests
	eval "CTEST_OUTPUT_ON_FAILURE=1 \
	  $(MAKE) -C builddir test ARGS=\"$(test_makeflags) $(test_discardflags) -R cppcheck\""
endif

override_dh_clean:
	rm -rf builddir
	dh_clean

=== debian/watch ===
Version: 5

Source: https://github.com/openturns/openturns/tags
Matching-Pattern: (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%openturns-$1.tar.gz%
